/***************************************/
/*       SNA/TAP to PDB converter      */
/*           by Alex Zolotov           */ 
/*        observer_page@mail.ru        */
/***************************************/
#include "stdio.h"

unsigned long aa; //filename "." pointer
unsigned char sna[900000];
unsigned char FileName[256];
unsigned char pdb[76]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                       0,0,0,0,0x3B,0x62,0xC2,0x5C,0x3B,0x62,0xC2,0x5C,0x3B,0x62,0xC2,0x5C,
                       0,0,0,0,0,0,0,0,0,0,0,0,0x53,0x4E,0x41,0x20,
                       0x5A,0x55,0x4C,0x55,0,0,0,0,0,0,0,0};
unsigned long fsize;
unsigned long rec[2]={0,0};
char typ[5]="SNAP";
unsigned short tap_typ[2];
FILE *f;


unsigned short MWORD(unsigned short val)  //Mirror word value.
{
  unsigned short val2;
  val2=val<<8;
  val>>=8;val+=val2;
  return val;
}

unsigned long MDWORD(unsigned long val)  //Mirror dword value.
{
  unsigned long val2;
  val2=0;
  val2+=((val&0x000000FF)<<24);
  val2+=((val&0x0000FF00)<<8);
  val2+=((val&0x00FF0000)>>8);
  val2+=((val&0xFF000000)>>24);
  return val2;
}

void SAVEPDB(void)
{
  long n,filep=0,a;
  char name[256];

  for(a=0;a<256;a++) name[a]=0;
  for(a=0;a<256;a++){name[a]=FileName[a];if(name[a]==0){break;}}
  name[aa+1]='P';
  name[aa+2]='D';
  name[aa+3]='B';
  name[aa+4]=0;
  for(a=0;a<256;a++){
    if(name[a]==0x5C){filep=a+1;}
  }

  f=fopen(name,"wb");
    for(a=0;a<31;a++){pdb[a]=FileName[a+filep];if(FileName[a+filep]==0){break;}}
  fwrite(pdb,1,76,f);
    n=MWORD(2);;
  fwrite(&n,1,2,f);
    rec[0]=MDWORD(94);  //type.
  fwrite(rec,1,8,f);
    rec[0]=MDWORD(98);  //SNA data
  fwrite(rec,1,8,f);

    //DATA:
  fwrite(typ,1,4,f);
  fwrite(sna,1,49179,f);

  fclose(f);
}

void SAVEPDB2(void)
{
  unsigned long bb,off;
  unsigned long n,filep=0,scr,blocks,a,aaa;
  char name[256];
  unsigned short b_size[512]; //Block size;

  for(a=0;a<256;a++) name[a]=0;
  for(a=0;a<256;a++){name[a]=FileName[a];if(name[a]==0){break;}}
  name[aa+1]='P';
  name[aa+2]='D';
  name[aa+3]='B';
  name[aa+4]=0;
  for(a=0;a<256;a++){
    if(name[a]==0x5C){filep=a+1;}
  }
  
  f=fopen(name,"wb");

  for(a=0;a<31;a++){pdb[a]=FileName[a+filep];if(FileName[a+filep]==0){break;}}
  fwrite(pdb,1,76,f);

  blocks=0;a=0;scr=255;
next_block:
  aaa=sna[a]+((unsigned short)(sna[a+1])<<8);
  if(aaa==6914){scr=blocks;}
  b_size[blocks]=aaa+2;blocks++;a+=2;a+=aaa;
  if(a<fsize){goto next_block;}
  //blocks - number of blocks on TAP file;
  
  n=MWORD(blocks+1);
  fwrite(&n,1,2,f);

  bb=blocks*8;
  rec[0]=MDWORD(76+2+8+bb);  //type. 76-header; 2-records; 8-record0; bb-blocks*8;
  fwrite(rec,1,8,f);

  rec[0]=MDWORD(76+2+8+bb+4);  //TAP data
  fwrite(rec,1,8,f);
  blocks--;off=76+2+8+bb+4;
  for(a=0;a<blocks;a++){
    off+=b_size[a];rec[0]=MDWORD(off);  //TAP data
    fwrite(rec,1,8,f);
  }

    //DATA:
  tap_typ[0]=MWORD(scr);      //screen block;
  fwrite(tap_typ,1,2,f);
  tap_typ[0]=MWORD(blocks+1); //number of blocks;
  fwrite(tap_typ,1,2,f);
  fwrite(sna,1,fsize,f);

  fclose(f);
}

char ConvertFile(void)
{
  char rr;
  long a;
  rr=0;

  f=fopen((const char*)FileName,"rb");
  fsize=fread(sna,1,900000,f);
  fclose(f);

  for(a=0;a<256;a++){if(FileName[a]==0){break;}if(FileName[a]=='.'){aa=a;}}
  if(FileName[aa+1]=='s'){FileName[aa+1]='S';}
  if(FileName[aa+1]=='S'){
    if(fsize<50000){
      SAVEPDB();rr=1;
    }
  }
  if(FileName[aa+1]=='t'){FileName[aa+1]='T';}
  if(FileName[aa+1]=='T'){
          SAVEPDB2();rr=1;
  }
  return rr;
}

int main(short argc, char **argv)
{
  short a;
  char *pnt;
  if(argc>1){
    pnt=argv[1]; 
    for(a=0;a<256;a++){FileName[a]=pnt[a];if(pnt[a]==0) break; }
    ConvertFile(); 
  }else{
    printf("USAGE: CONVERT xxx.SNA\n       CONVERT xxx.TAP\n");
  }
}

